#ifndef PHP_HTMLTMPLPRO_H
#define PHP_HTMLTMPLPRO_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "php.h"
#include "php_ini.h"
#include "ext/standard/info.h"
#include "Zend/zend_interfaces.h"

/* Define the entry point symbol
 * Zend will use when loading this module
 */
extern zend_module_entry htmltmplpro_module_entry;
#define phpext_htmltmplpro_ptr &htmltmplpro_module_entry

#ifdef PHP_WIN32
#define PHP_HTMLTMPLPRO_API __declspec(dllexport)
#else
#define PHP_HTMLTMPLPRO_API
#endif

#ifdef ZTS
#include "TSRM.h"
#endif

#define HTMLTMPLPRO_EXT_VERSION         "0.90"
#define HTMLTMPLPRO_EXT_NAME            "htmltmplpro"
#define HTMLTMPLPRO_EXT_VERSION_STRING        (HTMLTMPLPRO_EXT_NAME HTMLTMPLPRO_EXT_VERSION " (PHP " PHP_VERSION ")")

PHP_MINIT_FUNCTION(htmltmplpro);
PHP_MSHUTDOWN_FUNCTION(htmltmplpro);
//PHP_RINIT_FUNCTION(htmltmplpro);
//PHP_RSHUTDOWN_FUNCTION(htmltmplpro);
PHP_MINFO_FUNCTION(htmltmplpro);

static PHP_FUNCTION(htmltmplpro_versioninfo);

/* 
  	Declare any global variables you may need between the BEGIN
	and END macros here:     

ZEND_BEGIN_MODULE_GLOBALS(htmltmplpro)
	long  global_value;
	char *global_string;
ZEND_END_MODULE_GLOBALS(htmltmplpro)
*/

/* In every utility function you add that needs to use variables 
   in php_htmltmplpro_globals, call TSRMLS_FETCH(); after declaring other 
   variables used by that function, or better yet, pass in TSRMLS_CC
   after the last function argument and declare your utility function
   with TSRMLS_DC after the last declared argument.  Always refer to
   the globals in your function as HTMLTMPLPRO_G(variable).  You are 
   encouraged to rename these macros something shorter, see
   examples in any other php module directory.
*/

#ifdef ZTS
#define HTMLTMPLPRO_G(v) TSRMG(htmltmplpro_globals_id, zend_htmltmplpro_globals *, v)
#else
#define HTMLTMPLPRO_G(v) (htmltmplpro_globals.v)
#endif

/* for 5.x compatible builds */
#ifndef Z_ADDREF_P
#define Z_ADDREF_P(x) ZVAL_ADDREF(x)
#endif

#endif	/* PHP_HTMLTMPLPRO_H */

